#include<cstdio>  
#include<iostream>  
#include<algorithm>  
#include<cstdlib>  
#include<cstring>
#include<string>
#include<climits>
#include<vector>
#include<queue>
#include<cmath>
#define LL long long

using namespace std;

inline char nc(){
  ///*
  static char buf[100000],*p1=buf,*p2=buf;
  if (p1==p2) { p2=(p1=buf)+fread(buf,1,100000,stdin); if (p1==p2) return EOF; }
  return *p1++;
  //*/getchar();
}

inline void read(int &x){
  char c=nc(),b=1;
  for (;!(c>='0' && c<='9');c=nc()) if (c=='-') b=-1;
  for (x=0;c>='0' && c<='9';x=x*10+c-'0',c=nc()); x*=b;
}

inline void read(LL &x){
  char c=nc(),b=1;
  for (;!(c>='0' && c<='9');c=nc()) if (c=='-') b=-1;
  for (x=0;c>='0' && c<='9';x=x*10+c-'0',c=nc()); x*=b;
}

int wt,ss[19];
inline void print(int x){
	if (x<0) x=-x,putchar('-');
	if (!x) putchar(48); else {for (wt=0;x;ss[++wt]=x%10,x/=10);for (;wt;putchar(ss[wt]+48),wt--);}
}
inline void print(LL x){
	if (x<0) x=-x,putchar('-');
	if (!x) putchar(48); else {for (wt=0;x;ss[++wt]=x%10,x/=10);for (;wt;putchar(ss[wt]+48),wt--);}
}

int n,m,d1[5010],p1[5010],d2[5010],p2[5010];
bool v[5010];
struct data
{
	int x,y;
	data(int a=0,int b=0):x(a),y(b) {}
};
struct cmp
{
	bool operator() (data x,data y)
	{
		return x.x>y.x;
	}
};
vector <data> a[5010];
priority_queue<data,vector<data>,cmp> q;
const int inf=1000000000;

int main()
{
	read(n);read(m);
	int x,y,Z1,Z2;
	for (int i=1;i<=m;i++)
		read(x),read(y),read(Z1),read(Z2),a[x].push_back(data(y,Z1)),a[y].push_back(data(x,Z2));
	memset(v,false,sizeof(v));
	for (int i=1;i<=n;i++)
		d1[i]=inf;
	d1[1]=0;
	for (int i=0;i<a[1].size();i++)
		p1[a[1][i].x]=a[1][i].x,d1[a[1][i].x]=min(d1[a[1][i].x],a[1][i].y),q.push(data(d1[a[1][i].x],a[1][i].x));
	while (!q.empty())
	{
		int x=q.top().y,y=q.top().x;q.pop();
		if (y>d1[x]) continue;
		//d1[x]=y;
		if (x==1) continue;
		for (int i=0;i<a[x].size();i++)
			if (d1[a[x][i].x]>d1[x]+a[x][i].y)
				p1[a[x][i].x]=p1[x],d1[a[x][i].x]=d1[x]+a[x][i].y,q.push(data(d1[a[x][i].x],a[x][i].x));
	}
	for (int i=1;i<=n;i++)
		d2[i]=inf;
	d2[1]=0;p2[1]=1;
	for (int i=0;i<a[1].size();i++)
		if (p1[a[1][i].x]!=a[1][i].x)
			p2[a[1][i].x]=a[1][i].x,d2[a[1][i].x]=min(d2[a[1][i].x],a[1][i].y),q.push(data(d2[a[1][i].x],a[1][i].x));
		else
		{
			p2[a[1][i].x]=a[1][i].x,q.push(data(d2[a[1][i].x],a[1][i].x));
			if (d2[a[1][i].x]==inf) d2[a[1][i].x]=a[1][i].y;
		}
	while (!q.empty())
	{
		int x=q.top().y,y=q.top().x;q.pop();
		if (x==1) continue;
		for (int i=0;i<a[x].size();i++)
			if (d2[a[x][i].x]>d1[x]+a[x][i].y && (p1[a[x][i].x]!=p1[x] || p2[a[x][i].x]==0 || p2[a[x][i].x]==p1[a[x][i].x]) || p1[a[x][i].x]==p2[a[x][i].x] && p1[x]!=p2[a[x][i].x])
				p2[a[x][i].x]=p1[x],d2[a[x][i].x]=d1[x]+a[x][i].y,q.push(data(d2[a[x][i].x],a[x][i].x));
		for (int i=0;i<a[x].size();i++)
			if (d2[a[x][i].x]>d2[x]+a[x][i].y && (p1[a[x][i].x]!=p2[x] || p2[a[x][i].x]==0 || p2[a[x][i].x]==p1[a[x][i].x]) || p1[a[x][i].x]==p2[a[x][i].x] && p2[x]!=p2[a[x][i].x])
				p2[a[x][i].x]=p2[x],d2[a[x][i].x]=d2[x]+a[x][i].y,q.push(data(d2[a[x][i].x],a[x][i].x));
	}
	int ans=inf;
	for (int i=2;i<=n;i++)
		for (int j=0;j<a[i].size();j++)
			if (a[i][j].x==1)
			{
				if (i!=p1[i]) ans=min(ans,a[i][j].y+d1[i]);
				else if (i!=p2[i]) ans=min(ans,a[i][j].y+d2[i]);
			}
	print(ans),putchar('\n');
	return 0;
}
