#include<cstdio>  
#include<iostream>  
#include<algorithm>  
#include<cstdlib>  
#include<cstring>
#include<string>
#include<climits>
#include<vector>
#include<cmath>
#include<map>
#define LL long long
 
using namespace std;
 
inline char nc(){
  static char buf[100000],*p1=buf,*p2=buf;
  if (p1==p2) { p2=(p1=buf)+fread(buf,1,100000,stdin); if (p1==p2) return EOF; }
  return *p1++;
}
 
inline void read(int &x){
  char c=nc();int b=1;
  for (;!(c>='0' && c<='9');c=nc()) if (c=='-') b=-1;
  for (x=0;c>='0' && c<='9';x=x*10+c-'0',c=nc()); x*=b;
}
 
inline void read(LL &x){
  char c=nc();LL b=1;
  for (;!(c>='0' && c<='9');c=nc()) if (c=='-') b=-1;
  for (x=0;c>='0' && c<='9';x=x*10+c-'0',c=nc()); x*=b;
}

inline int read(char *s)
{
	char c=nc();int len=0;
	for(;!(c>='A' && c<='Z');c=nc()) if (c==EOF) return 0;
	for(;(c>='A' && c<='Z');s[len++]=c,c=nc());
	s[len++]='\0';
	return len;
}

inline void read(char &x){
  for (x=nc();!(x>='A' && x<='Z');x=nc());
}

int wt,ss[19];
inline void print(int x){
	if (x<0) x=-x,putchar('-'); 
	if (!x) putchar(48); else {
	for (wt=0;x;ss[++wt]=x%10,x/=10);
	for (;wt;putchar(ss[wt]+48),wt--);}
}
inline void print(LL x){
	if (x<0) x=-x,putchar('-');
	if (!x) putchar(48); else {for (wt=0;x;ss[++wt]=x%10,x/=10);for (;wt;putchar(ss[wt]+48),wt--);}
}

int n,m,k,b[200010];
struct ST
{
	int x,tag,sum;
}tree[800010];
struct data
{
	int l,r,y,x;
}a[200010];
vector<int> c[40010];

int Hash(int x)
{
    return lower_bound(b+1,b+1+k,x)-b;
}

void Pushdown(int x,int l,int r)
{
	if (tree[x].tag!=0)
	{
		tree[x<<1].tag+=tree[x].tag;tree[x<<1|1].tag+=tree[x].tag;
		tree[x].sum+=tree[x].tag*(r-l+1);tree[x].x+=tree[x].tag;
		tree[x].tag=0;
	}
}

void change(int lq,int rq,int l,int r,int x,int z)
{
	if (l>=lq && r<=rq) {tree[x].tag+=z;return ;}
	int mid=l+r>>1;
	Pushdown(x,l,r);
	if (lq<=mid) change(lq,rq,l,mid,x<<1,z);
	if (rq>mid) change(lq,rq,mid+1,r,x<<1|1,z);
	tree[x].sum=tree[x<<1].sum+tree[x<<1|1].sum+tree[x<<1].tag*(mid-l+1)+tree[x<<1|1].tag*(r-mid);
	tree[x].x=max(tree[x<<1].x+tree[x<<1].tag,tree[x<<1|1].x+tree[x<<1|1].tag);
}

int querysum(int lq,int rq,int l,int r,int x)
{
	if (l>=lq && r<=rq) return tree[x].sum+tree[x].tag*(r-l+1);
	int mid=l+r>>1;
	Pushdown(x,l,r);
	int sum=0;
	if (lq<=mid) sum+=querysum(lq,rq,l,mid,x<<1);
	if (rq>mid) sum+=querysum(lq,rq,mid+1,r,x<<1|1);
	tree[x].sum=tree[x<<1].sum+tree[x<<1|1].sum+tree[x<<1].tag*(mid-l+1)+tree[x<<1|1].tag*(r-mid);
	tree[x].x=max(tree[x<<1].x+tree[x<<1].tag,tree[x<<1|1].x+tree[x<<1|1].tag);
	return sum;
}

bool cmp(data x,data y)
{
	return x.y<y.y;
}

int main()
{
	read(n);
	k=0;int x;
	for (int i=1;i<=n;i++)
	{
		read(m);
		for (int j=1;j<=m;j++)
		{
			read(x),c[i].push_back(x);
			if (j%2==1) b[++k]=x;
		}
	}
	sort(b+1,b+1+k);
	k=unique(b+1,b+1+k)-b-1;
	m=0;int l,r,y;
	memset(tree,0,sizeof(tree));
	for (int i=1;i<=n;i++)
	{
		x=m;
		for (int j=0;j<c[i].size()-2;j++)
			if (j%2==0)
			{
				y=c[i][j+1],l=Hash(c[i][j]),r=Hash(c[i][j+2]);
				if (l>r) swap(l,r);
				a[++m].l=l+1,a[m].r=r,a[m].y=y;
			}
		y=c[i][c[i].size()-1],l=Hash(c[i][c[i].size()-2]),r=Hash(c[i][0]);
		if (l>r) swap(l,r);
		a[++m].l=l+1,a[m].r=r,a[m].y=y;
		sort(a+x+1,a+m+1,cmp);
		for (int j=x+1;j<=m;j++)
		{
			if (querysum(a[j].l,a[j].r,1,k,1)==0) a[j].x=1;else a[j].x=-1;
			change(a[j].l,a[j].r,1,k,1,a[j].x);
		}
	}
	sort(a+1,a+1+m,cmp);
	memset(tree,0,sizeof(tree));
	int ans=0;
	for (int i=1;i<=m;i++)
	{
		change(a[i].l,a[i].r,1,k,1,a[i].x),ans=max(ans,tree[1].tag+tree[1].x);
	}
	print(ans),puts("");
	return 0;
}
