#include<cstdio>  
#include<iostream>  
#include<algorithm>  
#include<cstdlib>  
#include<cstring>
#include<string>
#include<climits>
#include<vector>
#include<cmath>
#include<map>
#include<set>
#define LL long long
 
using namespace std;
 
inline char nc(){
  static char buf[100000],*p1=buf,*p2=buf;
  if (p1==p2) { p2=(p1=buf)+fread(buf,1,100000,stdin); if (p1==p2) return EOF; }
  return *p1++;
}
 
inline void read(int &x){
  char c=nc();int b=1;
  for (;!(c>='0' && c<='9');c=nc()) if (c=='-') b=-1;
  for (x=0;c>='0' && c<='9';x=x*10+c-'0',c=nc()); x*=b;
}
 
inline void read(LL &x){
  char c=nc();LL b=1;
  for (;!(c>='0' && c<='9');c=nc()) if (c=='-') b=-1;
  for (x=0;c>='0' && c<='9';x=x*10+c-'0',c=nc()); x*=b;
}

inline int read(char *s)
{
	char c=nc();int len=0;
	for(;!(c>='A' && c<='Z');c=nc()) if (c==EOF) return 0;
	for(;(c>='A' && c<='Z');s[len++]=c,c=nc());
	s[len++]='\0';
	return len;
}

inline void read(char &x){
  for (x=nc();!(x>='A' && x<='Z');x=nc());
}

int wt,ss[19];
inline void print(int x){
	if (x<0) x=-x,putchar('-'); 
	if (!x) putchar(48); else {
	for (wt=0;x;ss[++wt]=x%10,x/=10);
	for (;wt;putchar(ss[wt]+48),wt--);}
}
inline void print(LL x){
	if (x<0) x=-x,putchar('-');
	if (!x) putchar(48); else {for (wt=0;x;ss[++wt]=x%10,x/=10);for (;wt;putchar(ss[wt]+48),wt--);}
}

int T,n,m,P,p[110],ans[110],a[10010];
struct data
{
	double x;int prex,prey;
} f[110][10010];

bool check_prime(int x)
{
	for (int i=2;i<=sqrt(x);i++)
		if (x%i==0) return false;
	return true;
}

void init()
{
	P=0;
	for (int i=2;i<=400;i++)
		if (check_prime(i)) p[++P]=i;
}

int main()
{
	read(T);
	init();
	while (T--)
	{
		read(n);
		for (int i=0;i<=n;i++)
			f[1][i].x=-1.0;
		f[1][0].prex=0,f[1][0].prey=0,f[1][0].x=0.0;
		int x=p[1];
		while (x<=n) f[1][x].prex=0,f[1][x].prey=0,f[1][x].x=log((double)x),x*=p[1];
		for (int i=2;i<=P;i++)
		{
			for (int j=0;j<=n;j++)
			{
				f[i][j].x=f[i-1][j].x;
				f[i][j].prex=i-1,f[i][j].prey=j;
				x=p[i];
				while (j-x>=0)
				{
					if (f[i-1][j-x].x>=0.0)
					if (f[i-1][j-x].x+log(double(x))>f[i][j].x)
					{
						
						f[i][j].x=f[i-1][j-x].x+log(double(x));
						f[i][j].prex=i-1,f[i][j].prey=j-x;
					}
					x*=p[i];
				}
			}
		}
		double Max=0;int w=0;
		for (int i=0;i<=n;i++)
			if (f[P][i].x>Max) Max=f[P][i].x,w=i;
		x=P;int y=w,s=0,u,v,k=0;
		while (x!=0)
		{
			if (f[x][y].prey!=y) ans[++s]=y-f[x][y].prey,k+=y-f[x][y].prey;
			u=x,v=y;
			x=f[u][v].prex,y=f[u][v].prey;
		}
		while (k<n) k++,ans[++s]=1;
		sort(ans+1,ans+1+s);
		int q=1;
		for (int i=1;i<=s;i++)
		{
			if (ans[i]==1) a[q]=q;
			else
			{
				for (int j=q;j<q+ans[i]-1;j++)
					a[j]=j+1;
				a[q+ans[i]-1]=q;
			}
			q+=ans[i];
		}
		for (int i=1;i<n;i++)
			print(a[i]),putchar(' ');
		print(a[n]),puts("");
	}
	return 0;
}
